Add xref-pulse-on-jump
[emacs.git] / Makefile.in
blob858a34d942384937e7b4d6ca97775612e167a938
1 ### @configure_input@
3 # Copyright (C) 1992-2015 Free Software Foundation, Inc.
5 # This file is part of GNU Emacs.
7 # GNU Emacs is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # GNU Emacs is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with GNU Emacs. If not, see <http://www.gnu.org/licenses/>.
20 ### Commentary:
22 # make all to compile and build Emacs.
23 # make install to install it.
24 # make TAGS to update tags tables.
26 # make clean or make mostlyclean
27 # Delete all files from the current directory that are normally
28 # created by building the program. Don't delete the files that
29 # record the configuration. Also preserve files that could be made
30 # by building, but normally aren't because the distribution comes
31 # with them.
33 # Delete '.dvi' files here if they are not part of the distribution.
35 # make distclean
36 # Delete all files from the current directory that are created by
37 # configuring or building the program. If you have unpacked the
38 # source and built the program without creating any other files,
39 # 'make distclean' should leave only the files that were in the
40 # distribution.
42 # make maintainer-clean
43 # Delete everything from the current directory that can be
44 # reconstructed with this Makefile. This typically includes
45 # everything deleted by distclean, plus more: .elc files,
46 # C source files produced by Bison, tags tables, info files,
47 # and so on.
49 # make extraclean
50 # Still more severe - delete backup and autosave files, too.
51 # Also generated files that do not normally change and can be slow
52 # to rebuild (eg leim/ja-dic).
54 # make bootstrap
55 # Removes all the compiled files to force a new bootstrap from a
56 # clean slate, and then build in the normal way.
58 # make docs
59 # Make Emacs documentation files from their sources; requires makeinfo.
61 SHELL = @SHELL@
63 # This only matters when inheriting a CDPATH not starting with the
64 # current directory.
65 CDPATH=
67 # If Make doesn't predefine MAKE, set it here.
68 @SET_MAKE@
70 # ==================== Things 'configure' Might Edit ====================
72 cache_file = @cache_file@
73 CONFIGURE_FLAGS = --cache-file=$(cache_file)
75 AUTOCONF = @AUTOCONF@
76 AUTOMAKE = @AUTOMAKE@
77 AUTOHEADER = @AUTOHEADER@
78 ACLOCAL = @ACLOCAL@
79 AWK = @AWK@
81 EXEEXT=@EXEEXT@
83 ### These help us choose version- and architecture-specific directories
84 ### to install files in.
86 ### This should be the number of the Emacs version we're building,
87 ### like '24.5' or '25.0.50'.
88 version=@version@
90 ### This should be the name of the configuration we're building Emacs
91 ### for, like 'x86_64-unknown-linux-gnu' or 'powerpc-ibm-aix7.1.2.0'.
92 configuration=@configuration@
94 ### The nt/ subdirectory gets built only for MinGW
95 NTDIR=@NTDIR@
97 # 'make' verbosity.
98 AM_DEFAULT_VERBOSITY = @AM_DEFAULT_VERBOSITY@
100 AM_V_GEN = $(am__v_GEN_@AM_V@)
101 am__v_GEN_ = $(am__v_GEN_@AM_DEFAULT_V@)
102 am__v_GEN_0 = @echo " GEN " $@;
103 am__v_GEN_1 =
105 AM_V_at = $(am__v_at_@AM_V@)
106 am__v_at_ = $(am__v_at_@AM_DEFAULT_V@)
107 am__v_at_0 = @
108 am__v_at_1 =
110 # ==================== Where To Install Things ====================
112 # Location to install Emacs.app under GNUstep / Mac OS X.
113 # Later values may use these.
114 ns_appbindir=@ns_appbindir@
115 ns_appresdir=@ns_appresdir@
116 # Either yes or no depending on whether this is a relocatable Emacs.app.
117 ns_self_contained=@ns_self_contained@
119 # The default location for installation. Everything is placed in
120 # subdirectories of this directory. The default values for many of
121 # the variables below are expressed in terms of this one, so you may
122 # not need to change them. This defaults to /usr/local.
123 prefix=@prefix@
125 # Like 'prefix', but used for architecture-specific files.
126 exec_prefix=@exec_prefix@
128 # Where to install Emacs and other binaries that people will want to
129 # run directly (like etags).
130 bindir=@bindir@
132 # The root of the directory tree for read-only architecture-independent
133 # data files. ${datadir}, ${infodir} and ${mandir} are based on this.
134 datarootdir=@datarootdir@
136 # Where to install architecture-independent data files. ${lispdir}
137 # and ${etcdir} are subdirectories of this.
138 datadir=@datadir@
140 # Where to install and expect the files that Emacs modifies as it
141 # runs. These files are all architecture-independent.
142 # Right now, this is not used.
143 sharedstatedir=@sharedstatedir@
145 # Where to install and expect executable files to be run by Emacs
146 # rather than directly by users (and other architecture-dependent
147 # data, although Emacs does not have any). The executables
148 # are actually installed in ${archlibdir}, which is (normally)
149 # a subdirectory of this.
150 libexecdir=@libexecdir@
152 # Where to install Emacs's man pages.
153 # Note they contain cross-references that expect them to be in section 1.
154 mandir=@mandir@
155 man1dir=$(mandir)/man1
157 # Where to install and expect the info files describing Emacs.
158 infodir=@infodir@
159 # Info files not in the doc/misc directory (we get those via make echo-info).
160 INFO_NONMISC=emacs.info eintr.info elisp.info
162 # If no makeinfo was found and configured --without-makeinfo, "no"; else "yes".
163 HAVE_MAKEINFO=@HAVE_MAKEINFO@
165 # Directory for local state files for all programs.
166 localstatedir=@localstatedir@
168 # Where to look for bitmap files.
169 bitmapdir=@bitmapdir@
171 # Where to find the source code. The source code for Emacs's C kernel is
172 # expected to be in ${srcdir}/src, and the source code for Emacs's
173 # utility programs is expected to be in ${srcdir}/lib-src. This is
174 # set by the configure script's '--srcdir' option.
176 # We use $(srcdir) explicitly in dependencies so as not to depend on VPATH.
177 srcdir=@srcdir@
178 abs_srcdir=@abs_srcdir@
180 # Where the manpage source files are kept.
181 mansrcdir=$(srcdir)/doc/man
183 # Tell make where to find source files; this is needed for the makefiles.
184 VPATH=@srcdir@
186 # Where to find the application default.
187 x_default_search_path=@x_default_search_path@
189 # Where the etc/emacs.desktop file is to be installed.
190 desktopdir=$(datarootdir)/applications
192 # Where the etc/emacs.appdata.xml file is to be installed.
193 appdatadir=$(datarootdir)/appdata
195 # Where the etc/images/icons/hicolor directory is to be installed.
196 icondir=$(datarootdir)/icons
198 # The source directory for the icon files.
199 iconsrcdir=$(srcdir)/etc/images/icons
201 # ==================== Emacs-specific directories ====================
203 # These variables hold the values Emacs will actually use. They are
204 # based on the values of the standard Make variables above.
206 # Where to install the lisp files distributed with Emacs.
207 # This includes the Emacs version, so that the lisp files for different
208 # versions of Emacs will install themselves in separate directories.
209 lispdir=@lispdir@
211 # Directories Emacs should search for standard lisp files.
212 # The default is ${lispdir}.
213 standardlisppath=@standardlisppath@
215 # Directories Emacs should search for lisp files specific to this
216 # site (i.e. customizations), before consulting ${standardlisppath}.
217 # This should be a colon-separated list of directories.
218 locallisppath=@locallisppath@
220 # Where Emacs will search to find its lisp files. Before
221 # changing this, check to see if your purpose wouldn't
222 # better be served by changing locallisppath. This
223 # should be a colon-separated list of directories.
224 # The default is ${locallisppath}:${standardlisppath}.
225 lisppath=@lisppath@
227 # Where Emacs will search for its lisp files while building.
228 # This is only used during the process of compiling Emacs,
229 # to help Emacs find its lisp files before they've been installed
230 # in their final location.
231 # This should be a colon-separated list of directories.
232 # Normally it points to the lisp/ directory in the sources.
233 # NB lread.c relies on lisp/ being first here.
234 buildlisppath=${abs_srcdir}/lisp
236 # Where to install the other architecture-independent
237 # data files distributed with Emacs (like the tutorial,
238 # the cookie recipes and the Zippy database). This path
239 # usually contains the Emacs version number, so the data
240 # files for multiple versions of Emacs may be installed
241 # at once.
242 etcdir=@etcdir@
244 # Where to put executables to be run by Emacs rather than
245 # the user. This path usually includes the Emacs version
246 # and configuration name, so that multiple configurations
247 # for multiple versions of Emacs may be installed at
248 # once.
249 archlibdir=@archlibdir@
251 # Where to put the etc/DOC file.
252 etcdocdir=@etcdocdir@
254 # Where to install Emacs game score files.
255 gamedir=@gamedir@
257 # ==================== Utility Programs for the Build ====================
259 # Allow the user to specify the install program.
260 # Note that if the system does not provide a suitable install,
261 # configure will use build-aux/install-sh. Annoyingly, it does
262 # not use an absolute path. So we must take care to always run
263 # INSTALL-type commands from the directory containing the Makefile.
264 # This explains (I think) the cd thisdir seen in several install rules.
265 INSTALL = @INSTALL@
266 INSTALL_PROGRAM = @INSTALL_PROGRAM@
267 INSTALL_DATA = @INSTALL_DATA@
268 INSTALL_INFO = @INSTALL_INFO@
269 # By default, we uphold the dignity of our programs.
270 INSTALL_STRIP =
271 MKDIR_P = @MKDIR_P@
272 # Create a link to a file in the same directory as the target.
273 LN_S_FILEONLY = @LN_S_FILEONLY@
275 # We use gzip to compress installed .el and some .txt files.
276 GZIP_PROG = @GZIP_PROG@
278 # ============================= Targets ==============================
280 # Program name transformation.
281 TRANSFORM = @program_transform_name@
283 # What emacs should be called when installed.
284 EMACS_NAME = `echo emacs | sed '$(TRANSFORM)'`
285 EMACS = ${EMACS_NAME}${EXEEXT}
286 EMACSFULL = `echo emacs-${version} | sed '$(TRANSFORM)'`${EXEEXT}
288 # Subdirectories to make recursively.
289 SUBDIR = $(NTDIR) lib lib-src src lisp
291 # The subdir makefiles created by config.status.
292 SUBDIR_MAKEFILES_IN = @SUBDIR_MAKEFILES_IN@
293 SUBDIR_MAKEFILES = `echo $(SUBDIR_MAKEFILES_IN:.in=) | sed 's|$(srcdir)/||g'`
295 # Subdirectories to install, and where they'll go. lib-src's and nt's
296 # makefiles know how to install them, so we don't do that here.
297 # Directories that cannot simply be copied, eg info, are treated
298 # separately.
299 COPYDIR = ${srcdir}/etc ${srcdir}/lisp
300 COPYDESTS = "$(DESTDIR)${etcdir}" "$(DESTDIR)${lispdir}"
302 all: ${SUBDIR} info
304 .PHONY: all ${SUBDIR} blessmail epaths-force epaths-force-w32 etc-emacsver
306 # If configure were to just generate emacsver.tex from emacsver.tex.in
307 # in the normal way, the timestamp of emacsver.tex would always be
308 # newer than that of the pdf files, which are prebuilt in release tarfiles.
309 # So we use this rule, and move-if-change, to avoid that.
310 etc-emacsver:
311 majorversion=`echo ${version} | sed 's/\..*//'`; \
312 sed "s/[@]majorversion@/$${majorversion}/" \
313 ${srcdir}/etc/refcards/emacsver.tex.in > emacsver.tex.$$$$ && \
314 ${srcdir}/build-aux/move-if-change emacsver.tex.$$$$ \
315 ${srcdir}/etc/refcards/emacsver.tex
317 removenullpaths=sed -e 's/^:*//' -e 's/:*$$//g' -e 's/::*/:/g'
319 # Generate epaths.h from epaths.in. This target is invoked by 'configure'.
320 # See comments in configure.ac for why it is done this way, as opposed
321 # to just letting configure generate epaths.h from epaths.in in a
322 # similar way to how Makefile is made from Makefile.in.
323 epaths-force:
324 @for dir in '$(abs_srcdir)' '$(lispdir)' '$(archlibdir)'; do \
325 case $$dir in \
326 *:*) \
327 echo >&2 "Build or installation directory '$$dir'"; \
328 echo >&2 "cannot contain ':'."; \
329 exit 1;; \
330 esac; \
331 done
332 @(standardlisppath=`echo "${standardlisppath}" | ${removenullpaths}` ; \
333 locallisppath=`echo "${locallisppath}" | ${removenullpaths}` ; \
334 buildlisppath=`echo "${buildlisppath}" | ${removenullpaths}` ; \
335 x_default_search_path=`echo ${x_default_search_path}`; \
336 gamedir=`echo ${gamedir}`; \
337 sed < ${srcdir}/src/epaths.in > epaths.h.$$$$ \
338 -e 's;\(#.*PATH_LOADSEARCH\).*$$;\1 "'"$${standardlisppath}"'";' \
339 -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "'"$${locallisppath}"'";' \
340 -e 's;\(#.*PATH_DUMPLOADSEARCH\).*$$;\1 "'"$${buildlisppath}"'";' \
341 -e 's;\(#.*PATH_EXEC\).*$$;\1 "${archlibdir}";' \
342 -e 's;\(#.*PATH_INFO\).*$$;\1 "${infodir}";' \
343 -e 's;\(#.*PATH_DATA\).*$$;\1 "${etcdir}";' \
344 -e 's;\(#.*PATH_BITMAPS\).*$$;\1 "${bitmapdir}";' \
345 -e 's;\(#.*PATH_X_DEFAULTS\).*$$;\1 "${x_default_search_path}";' \
346 -e 's;\(#.*PATH_GAME\).*$$;\1 "${gamedir}";' \
347 -e 's;\(#.*PATH_DOC\).*$$;\1 "${etcdocdir}";') && \
348 ${srcdir}/build-aux/move-if-change epaths.h.$$$$ src/epaths.h
350 # The w32 build needs a slightly different editing, and it uses
351 # nt/epaths.nt as the template.
353 # Use the value of ${locallisppath} supplied by 'configure',
354 # to support the --enable-locallisppath argument.
356 # In this case, the paths written to 'src/epaths.h' must be in native
357 # MS-Windows format (e.g. 'c:/foo/bar'), because temacs is a MinGW
358 # program that doesn't support MSYS-style paths (e.g. '/c/foo/bar' or
359 # '/foo/bar').
360 epaths-force-w32:
361 @(w32srcdir=`${srcdir}/build-aux/msys-to-w32 "${abs_srcdir}"`; \
362 w32prefix=`${srcdir}/build-aux/msys-to-w32 "${prefix}"`; \
363 w32locallisppath=`${srcdir}/build-aux/msys-to-w32 "${locallisppath}"` ; \
364 w32locallisppath=$${w32locallisppath//$${w32prefix}/"%emacs_dir%"} ; \
365 sed < ${srcdir}/nt/epaths.nt > epaths.h.$$$$ \
366 -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "'"$${w32locallisppath//;/\\;}"'";' \
367 -e '/^.*#/s/@VER@/${version}/g' \
368 -e '/^.*#/s/@CFG@/${configuration}/g' \
369 -e "/^.*#/s|@SRC@|$${w32srcdir}|g") && \
370 ${srcdir}/build-aux/move-if-change epaths.h.$$$$ src/epaths.h
372 # If lib/Makefile would build files in '.', then build them before
373 # building 'lib', to avoid races with parallel makes.
374 lib: am--refresh
376 lib-src src: $(NTDIR) lib
378 src: lib-src
380 # We need to build 'emacs' in 'src' to compile the *.elc files in 'lisp'.
381 lisp: src
383 # These targets should be "${SUBDIR} without 'src'".
384 lib lib-src lisp nt: Makefile
385 $(MAKE) -C $@ all
387 # Ideally, VCSWITNESS should be a file that is modified whenever the
388 # repository registers a commit from either a local checkin or a
389 # repository pull. In git there is no single file that guarantees
390 # this, but the local log for the current head should be close enough.
392 # Pass an unexpanded $srcdir to src's Makefile, which then
393 # expands it using its own value of srcdir (which points to the
394 # source directory of src/).
395 dirstate = .git/logs/HEAD
396 VCSWITNESS = $(if $(wildcard $(srcdir)/$(dirstate)),$$(srcdir)/../$(dirstate))
397 src: Makefile
398 $(MAKE) -C $@ VCSWITNESS='$(VCSWITNESS)' all
400 blessmail: Makefile src
401 $(MAKE) -C lib-src maybe-blessmail
403 # We used to have one rule per */Makefile.in, but that leads to race
404 # conditions with parallel makes, so let's assume that the time stamp on
405 # ./Makefile is representative of the time stamp on all the other Makefiles.
407 # config.status overrides MAKEFILE_NAME with a bogus name when creating
408 # src/epaths.h, so that 'make epaths-force' does not recursively invoke
409 # config.status and overwrite config.status while executing it (Bug#11214).
411 # 'make bootstrap' overrides MAKEFILE_NAME to a nonexistent file but
412 # then attempts to build that file. This forces 'Makefile', 'lib/Makefile',
413 # etc. to be built without running into similar recursion problems.
414 MAKEFILE_NAME = Makefile
415 $(MAKEFILE_NAME): config.status $(srcdir)/src/config.in \
416 $(srcdir)/Makefile.in $(SUBDIR_MAKEFILES_IN) $(srcdir)/src/lisp.mk
417 MAKE='$(MAKE)' ./config.status
419 # Don't erase these files if make is interrupted while refreshing them.
420 .PRECIOUS: Makefile config.status
422 config.status: ${srcdir}/configure
423 if [ -x ./config.status ]; then \
424 $(CFG) ./config.status --recheck; \
425 else \
426 $(CFG) $(srcdir)/configure $(CONFIGURE_FLAGS); \
429 AUTOCONF_INPUTS = $(srcdir)/configure.ac $(srcdir)/aclocal.m4
431 $(srcdir)/configure: $(AUTOCONF_INPUTS)
432 cd ${srcdir} && ${AUTOCONF}
434 ACLOCAL_PATH = @ACLOCAL_PATH@
435 ACLOCAL_INPUTS = $(srcdir)/configure.ac $(srcdir)/m4/*.m4
436 $(srcdir)/aclocal.m4: $(ACLOCAL_INPUTS)
437 cd $(srcdir) && ACLOCAL_PATH='$(ACLOCAL_PATH)' $(ACLOCAL) -I m4
439 AUTOMAKE_INPUTS = $(srcdir)/aclocal.m4 $(srcdir)/lib/Makefile.am \
440 $(srcdir)/lib/gnulib.mk
441 $(srcdir)/lib/Makefile.in: $(AUTOMAKE_INPUTS)
442 cd $(srcdir) && $(AUTOMAKE) --gnu -a -c lib/Makefile
444 # Regenerate files that this makefile would have made, if this makefile
445 # had been built by Automake. The name 'am--refresh' is for
446 # compatibility with subsidiary Automake-generated makefiles.
447 am--refresh: $(srcdir)/aclocal.m4 $(srcdir)/configure $(srcdir)/src/config.in
448 .PHONY: am--refresh
450 $(srcdir)/src/config.in: $(srcdir)/src/stamp-h.in
451 @ # Usually, there's no need to rebuild src/config.in just
452 @ # because stamp-h.in has changed (since building stamp-h.in
453 @ # refreshes config.in as well), but if config.in is missing
454 @ # then we really need to do something more.
455 $(if $(wildcard $@),,cd $(srcdir) && $(AUTOHEADER))
456 $(srcdir)/src/stamp-h.in: $(AUTOCONF_INPUTS)
457 cd ${srcdir} && ${AUTOHEADER}
458 rm -f $@
459 echo timestamp > $@
461 # ==================== Installation ====================
463 .PHONY: install install-arch-dep install-arch-indep install-etcdoc install-info
464 .PHONY: install-man install-etc install-strip install-$(NTDIR)
465 .PHONY: uninstall uninstall-$(NTDIR)
467 ## If we let lib-src do its own installation, that means we
468 ## don't have to duplicate the list of utilities to install in
469 ## this Makefile as well.
471 install: all install-arch-indep install-etcdoc install-arch-dep install-$(NTDIR) blessmail
472 @true
474 ## Ensure that $subdir contains a subdirs.el file.
475 ## Here and elsewhere, we set the umask so that any created files are
476 ## world-readable.
477 ## TODO it might be good to warn about non-standard permissions of
478 ## pre-existing directories, but that does not seem easy.
479 write_subdir=if [ -f "$${subdir}/subdirs.el" ]; \
480 then true; \
481 else \
482 umask 022; \
483 ${MKDIR_P} "$${subdir}"; \
484 (echo "(if (fboundp 'normal-top-level-add-subdirs-to-load-path)"; \
485 echo " (normal-top-level-add-subdirs-to-load-path))") \
486 > "$${subdir}/subdirs.el"; \
489 ### Install the executables that were compiled specifically for this machine.
490 ### We do install-arch-indep first because the executable needs the
491 ### Lisp files and DOC file to work properly.
492 install-arch-dep: src install-arch-indep install-etcdoc install-$(NTDIR)
493 umask 022; ${MKDIR_P} "$(DESTDIR)${bindir}"
494 $(MAKE) -C lib-src install
495 if test "${ns_self_contained}" = "no"; then \
496 ${INSTALL_PROGRAM} $(INSTALL_STRIP) src/emacs${EXEEXT} "$(DESTDIR)${bindir}/$(EMACSFULL)" || exit 1 ; \
497 chmod 1755 "$(DESTDIR)${bindir}/$(EMACSFULL)" || true; \
498 if test "x${NO_BIN_LINK}" = x; then \
499 rm -f "$(DESTDIR)${bindir}/$(EMACS)" ; \
500 cd "$(DESTDIR)${bindir}" && $(LN_S_FILEONLY) $(EMACSFULL) $(EMACS); \
501 fi; \
502 else \
503 subdir=${ns_appresdir}/site-lisp; \
504 ${write_subdir} || exit 1; \
505 rm -rf ${ns_appresdir}/share; \
508 ### Windows-specific install target for installing programs produced
509 ### in nt/, and its Posix do-nothing shadow.
510 install-:
511 install-nt:
512 $(MAKE) -C $(NTDIR) install
514 ## In the share directory, we are deleting:
515 ## applications (with emacs.desktop, also found in etc/)
516 ## emacs (basically empty except for unneeded site-lisp directories)
517 ## icons (duplicates etc/images/icons/hicolor)
519 ## This is install-etc for everything except self-contained-ns builds.
520 ## For them, it is empty.
521 INSTALL_ARCH_INDEP_EXTRA = @INSTALL_ARCH_INDEP_EXTRA@
523 ## http://lists.gnu.org/archive/html/emacs-devel/2007-10/msg01672.html
524 ## Needs to be the user running install, so configure can't set it.
525 set_installuser=for installuser in $${LOGNAME} $${USERNAME} $${USER} \
526 `id -un 2> /dev/null`; do \
527 [ -n "$${installuser}" ] && break ; \
528 done
530 ### Install the files that are machine-independent.
531 ### Most of them come straight from the distribution; the exception is
532 ### the DOC file, which is copied from the build directory.
534 ## We delete each directory in ${COPYDESTS} before we copy into it;
535 ## that way, we can reinstall over directories that have been put in
536 ## place with their files read-only (perhaps because they are checked
537 ## into RCS). In order to make this safe, we make sure that the
538 ## source exists and is distinct from the destination.
540 ## We delete etc/DOC* because there may be irrelevant DOC files from
541 ## other builds in the source directory. This is ok because we just
542 ## deleted the entire installed etc/ directory and recreated it.
543 ## install-etcdoc installs the relevant DOC.
545 ## Note that we install etc/refcards/*.ps if present.
546 ## TODO we should compress these if GZIP_PROG is set.
547 ## It would be simpler to have a separate install rule for etc/refcards
548 ## (maybe move it to doc/refcards?).
550 ## Note that the Makefiles in the etc directory are potentially useful
551 ## in an installed Emacs, so should not be excluded.
553 ## We always create the _default_ locallisppath directories, and
554 ## ensure that they contain a subdirs.el file (via write_subdir).
555 ## This is true even if locallisppath has a non-default value.
556 ## In case of non-default value, we used to create the specified directories,
557 ## but not add subdirs.el to them. This was a strange halfway house.
558 ## Nowadays we do not create non-default directories.
560 ## Note that we use tar instead of plain old cp -R/-r because the latter
561 ## is apparently not portable (even in 2012!).
562 ## http://lists.gnu.org/archive/html/emacs-devel/2012-05/msg00278.html
563 ## I have no idea which platforms Emacs supports where cp -R does not
564 ## work correctly, and therefore no idea when tar can be replaced.
565 ## See also these comments from 2004 about cp -r working fine:
566 ## http://lists.gnu.org/archive/html/autoconf-patches/2004-11/msg00005.html
567 install-arch-indep: lisp install-info install-man ${INSTALL_ARCH_INDEP_EXTRA}
568 -set ${COPYDESTS} ; \
569 unset CDPATH; \
570 $(set_installuser); \
571 for dir in ${COPYDIR} ; do \
572 [ -d $${dir} ] || exit 1 ; \
573 dest="$$1" ; shift ; \
574 if [ -d "$${dest}" ]; then \
575 exp_dest=`cd "$${dest}" && /bin/pwd`; \
576 [ "$$exp_dest" = "`cd $${dir} && /bin/pwd`" ] && continue ; \
577 else true; \
578 fi; \
579 rm -rf "$${dest}" ; \
580 umask 022; ${MKDIR_P} "$${dest}" ; \
581 echo "Copying $${dir} to $${dest}..." ; \
582 (cd $${dir}; tar -chf - . ) \
583 | (cd "$${dest}"; umask 022; \
584 tar -xvf - && cat > /dev/null) || exit 1; \
585 if [ "$${dir}" = "${srcdir}/etc" ]; then \
586 rm -f "$${dest}/DOC"* ; \
587 rm -f "$${dest}/refcards"/*.aux "$${dest}/refcards"/*.dvi; \
588 rm -f "$${dest}/refcards"/*.log; \
589 else true; \
590 fi; \
591 (cd "$${dest}" || exit 1; \
592 for subdir in `find . -type d -print` ; do \
593 chmod a+rx $${subdir} ; \
594 rm -f $${subdir}/.gitignore ; \
595 rm -f $${subdir}/.arch-inventory ; \
596 rm -f $${subdir}/.DS_Store ; \
597 rm -f $${subdir}/\#* ; \
598 rm -f $${subdir}/.\#* ; \
599 rm -f $${subdir}/*~ ; \
600 rm -f $${subdir}/*.orig ; \
601 rm -f $${subdir}/ChangeLog* ; \
602 [ "$${dir}" != "${srcdir}/etc" ] && \
603 rm -f $${subdir}/[mM]akefile*[.-]in $${subdir}/[mM]akefile ; \
604 done ); \
605 find "$${dest}" -exec chown $${installuser} {} ';' ;\
606 done
607 -rm -f "$(DESTDIR)${lispdir}/subdirs.el"
608 umask 022; $(srcdir)/build-aux/update-subdirs "$(DESTDIR)${lispdir}"
609 subdir="$(DESTDIR)${datadir}/emacs/${version}/site-lisp" ; \
610 ${write_subdir}
611 subdir="$(DESTDIR)${datadir}/emacs/site-lisp" ; \
612 ${write_subdir} || true
613 [ -z "${GZIP_PROG}" ] || { \
614 echo "Compressing *.el etc. ..." && \
615 cd "$(DESTDIR)${lispdir}" && \
616 for f in `find . -name "*.elc" -print | sed 's/.elc$$/.el/'`; do \
617 ${GZIP_PROG} -9n "$$f"; \
618 done; \
619 ${GZIP_PROG} -9n "../etc/publicsuffix.txt"; \
621 -chmod -R a+r "$(DESTDIR)${datadir}/emacs/${version}" ${COPYDESTS}
623 ## The above chmods are needed because "umask 022; tar ..." is not
624 ## guaranteed to do the right thing; eg if we are root and tar is
625 ## preserving source permissions.
627 ## Note that install-arch-indep deletes and recreates the entire
628 ## installed etc/ directory, so we need it to run before this does.
629 install-etcdoc: src install-arch-indep
630 -unset CDPATH; \
631 umask 022; ${MKDIR_P} "$(DESTDIR)${etcdocdir}" ; \
632 exp_etcdocdir=`cd "$(DESTDIR)${etcdocdir}"; /bin/pwd`; \
633 if [ "`cd ./etc; /bin/pwd`" != "$$exp_etcdocdir" ]; \
634 then \
635 docfile="DOC"; \
636 echo "Copying etc/$${docfile} to $(DESTDIR)${etcdocdir} ..." ; \
637 ${INSTALL_DATA} etc/$${docfile} "$(DESTDIR)${etcdocdir}/$${docfile}"; \
638 $(set_installuser); \
639 chown $${installuser} "$(DESTDIR)${etcdocdir}/$${docfile}" || true ; \
640 else true; fi
642 ## FIXME:
643 ## If info/dir is missing, but we have install-info, we should let
644 ## that handle it. If info/dir is present and we do not have install-info,
645 ## we should check for missing entries and add them by hand.
647 ## FIXME:
648 ## If HAVE_MAKEINFO = no and there are no info files, do not install info/dir.
649 install-info: info
650 umask 022; ${MKDIR_P} "$(DESTDIR)${infodir}"
651 -unset CDPATH; \
652 thisdir=`/bin/pwd`; \
653 exp_infodir=`cd "$(DESTDIR)${infodir}" && /bin/pwd`; \
654 if [ "`cd ${srcdir}/info && /bin/pwd`" = "$$exp_infodir" ]; then \
655 true; \
656 else \
657 [ -f "$(DESTDIR)${infodir}/dir" ] || \
658 [ ! -f ${srcdir}/info/dir ] || \
659 ${INSTALL_DATA} ${srcdir}/info/dir "$(DESTDIR)${infodir}/dir"; \
660 info_misc=`$(MAKE) --no-print-directory -s -C doc/misc echo-info`; \
661 cd ${srcdir}/info ; \
662 for elt in ${INFO_NONMISC} $${info_misc}; do \
663 test "$(HAVE_MAKEINFO)" = "no" && test ! -f $$elt && continue; \
664 for f in `ls $$elt $$elt-[1-9] $$elt-[1-9][0-9] 2>/dev/null`; do \
665 (cd "$${thisdir}"; \
666 ${INSTALL_DATA} ${srcdir}/info/$$f "$(DESTDIR)${infodir}/$$f"); \
667 [ -n "${GZIP_PROG}" ] || continue ; \
668 rm -f "$(DESTDIR)${infodir}/$$f.gz"; \
669 ${GZIP_PROG} -9n "$(DESTDIR)${infodir}/$$f"; \
670 done; \
671 (cd "$${thisdir}"; \
672 ${INSTALL_INFO} --info-dir="$(DESTDIR)${infodir}" "$(DESTDIR)${infodir}/$$elt"); \
673 done; \
676 ## "gzip || true" is because some gzips exit with non-zero status
677 ## if compression would not reduce the file size. Eg, the gzip in
678 ## OpenBSD 4.9 seems to do this (2013/03). In Emacs, this can
679 ## only happen with the tiny ctags.1 manpage. We don't really care if
680 ## ctags.1 is compressed or not. "gzip -f" is another option here,
681 ## but not sure if portable.
682 install-man:
683 umask 022; ${MKDIR_P} "$(DESTDIR)${man1dir}"
684 thisdir=`/bin/pwd`; \
685 cd ${mansrcdir}; \
686 for page in *.1; do \
687 test "$$page" = ChangeLog.1 && continue; \
688 dest=`echo "$${page}" | sed -e 's/\.1$$//' -e '$(TRANSFORM)'`.1; \
689 (cd "$${thisdir}"; \
690 ${INSTALL_DATA} ${mansrcdir}/$${page} "$(DESTDIR)${man1dir}/$${dest}"); \
691 [ -n "${GZIP_PROG}" ] || continue ; \
692 rm -f "$(DESTDIR)${man1dir}/$${dest}.gz"; \
693 ${GZIP_PROG} -9n "$(DESTDIR)${man1dir}/$${dest}" || true; \
694 done
696 ## Install those items from etc/ that need to end up elsewhere.
698 ## If you prefer, choose "emacs22" at installation time.
699 ## Note: emacs22 does not have all the resolutions.
700 EMACS_ICON=emacs
702 install-etc:
703 umask 022; ${MKDIR_P} "$(DESTDIR)${desktopdir}"
704 tmp=etc/emacs.tmpdesktop; rm -f $${tmp}; \
705 emacs_name=`echo emacs | sed '$(TRANSFORM)'`; \
706 sed -e "/^Exec=emacs/ s/emacs/$${emacs_name}/" \
707 -e "/^Icon=emacs/ s/emacs/$${emacs_name}/" \
708 ${srcdir}/etc/emacs.desktop > $${tmp}; \
709 ${INSTALL_DATA} $${tmp} "$(DESTDIR)${desktopdir}/${EMACS_NAME}.desktop"; \
710 rm -f $${tmp}
711 umask 022; ${MKDIR_P} "$(DESTDIR)${appdatadir}"
712 tmp=etc/emacs.tmpappdata; rm -f $${tmp}; \
713 sed -e "s/emacs\.desktop/${EMACS_NAME}.desktop/" \
714 ${srcdir}/etc/emacs.appdata.xml > $${tmp}; \
715 ${INSTALL_DATA} $${tmp} "$(DESTDIR)${appdatadir}/${EMACS_NAME}.appdata.xml"; \
716 rm -f $${tmp}
717 thisdir=`/bin/pwd`; \
718 cd ${iconsrcdir} || exit 1; umask 022 ; \
719 for dir in */*/apps */*/mimetypes; do \
720 [ -d $${dir} ] || continue ; \
721 ( cd "$${thisdir}"; ${MKDIR_P} "$(DESTDIR)${icondir}/$${dir}" ) ; \
722 for icon in $${dir}/${EMACS_ICON}[.-]*; do \
723 [ -r $${icon} ] || continue ; \
724 ext=`echo "$${icon}" | sed -e 's|.*\.||'`; \
725 dest=`echo "$${icon}" | sed -e 's|.*/||' -e "s|\.$${ext}$$||" -e 's/$(EMACS_ICON)/emacs/' -e '$(TRANSFORM)'`.$${ext} ; \
726 ( cd "$${thisdir}"; \
727 ${INSTALL_DATA} ${iconsrcdir}/$${icon} "$(DESTDIR)${icondir}/$${dir}/$${dest}" ) \
728 || exit 1; \
729 done ; \
730 done
732 ### Build Emacs and install it, stripping binaries while installing them.
733 install-strip:
734 $(MAKE) INSTALL_STRIP=-s install
736 ### Delete all the installed files that the 'install' target would
737 ### create (but not the noninstalled files such as 'make all' would create).
739 ### Don't delete the lisp and etc directories if they're in the source tree.
740 uninstall: uninstall-$(NTDIR) uninstall-doc
741 $(MAKE) -C lib-src uninstall
742 -unset CDPATH; \
743 for dir in "$(DESTDIR)${lispdir}" "$(DESTDIR)${etcdir}" ; do \
744 if [ -d "$${dir}" ]; then \
745 case `cd "$${dir}" ; /bin/pwd` in \
746 "`cd ${srcdir} ; /bin/pwd`"* ) ;; \
747 * ) rm -rf "$${dir}" ;; \
748 esac ; \
749 case "$${dir}" in \
750 "$(DESTDIR)${datadir}/emacs/${version}"/* ) \
751 rm -rf "$(DESTDIR)${datadir}/emacs/${version}" \
752 ;; \
753 esac ; \
754 fi ; \
755 done
756 -rm -rf "$(DESTDIR)${libexecdir}/emacs/${version}"
757 thisdir=`/bin/pwd`; \
758 (info_misc=`$(MAKE) --no-print-directory -s -C doc/misc echo-info`; \
759 if cd "$(DESTDIR)${infodir}"; then \
760 for elt in ${INFO_NONMISC} $${info_misc}; do \
761 (cd "$${thisdir}"; \
762 $(INSTALL_INFO) --remove --info-dir="$(DESTDIR)${infodir}" "$(DESTDIR)${infodir}/$$elt"); \
763 if [ -n "${GZIP_PROG}" ]; then \
764 ext=.gz; else ext=; fi; \
765 rm -f $$elt$$ext $$elt-[1-9]$$ext $$elt-[1-9][0-9]$$ext; \
766 done; \
768 (if [ -n "${GZIP_PROG}" ]; then \
769 ext=.gz; else ext=; fi; \
770 if cd ${mansrcdir}; then \
771 for page in *.1; do \
772 rm -f "$(DESTDIR)${man1dir}"/`echo "$${page}" | sed -e 's/\.1$$//' -e '$(TRANSFORM)'`.1$$ext; done; \
774 (cd "$(DESTDIR)${bindir}" && rm -f $(EMACSFULL) $(EMACS) || true)
775 (if cd "$(DESTDIR)${icondir}"; then \
776 rm -f hicolor/*x*/apps/${EMACS_NAME}.png \
777 hicolor/scalable/apps/${EMACS_NAME}.svg \
778 hicolor/scalable/mimetypes/`echo emacs-document | sed '$(TRANSFORM)'`.svg; \
780 -rm -f "$(DESTDIR)${desktopdir}/${EMACS_NAME}.desktop"
781 -rm -f "$(DESTDIR)${appdatadir}/${EMACS_NAME}.appdata.xml"
782 for file in snake-scores tetris-scores; do \
783 file="$(DESTDIR)${gamedir}/$${file}"; \
784 [ -s "$${file}" ] || rm -f "$$file"; \
785 done
787 ### Windows-specific uninstall target for removing programs produced
788 ### in nt/, and its Posix do-nothing shadow.
789 uninstall-:
790 uninstall-nt:
791 $(MAKE) -C $(NTDIR) uninstall
793 # ==================== Cleaning up and miscellanea ====================
795 .PHONY: mostlyclean clean distclean bootstrap-clean maintainer-clean extraclean
797 ## Eg:
798 ## src_clean:
799 ## make -C src clean
800 define submake_template
801 .PHONY: $(1)_$(2)
802 $(1)_$(2):
803 $$(MAKE) -C $(1) $(2)
804 endef
806 ### 'mostlyclean'
807 ### Like 'clean', but may refrain from deleting a few files that people
808 ### normally don't want to recompile. For example, the 'mostlyclean'
809 ### target for GCC does not delete 'libgcc.a', because recompiling it
810 ### is rarely necessary and takes a lot of time.
811 mostlyclean_dirs = src oldXMenu lwlib lib lib-src nt doc/emacs doc/misc \
812 doc/lispref doc/lispintro
814 $(foreach dir,$(mostlyclean_dirs),$(eval $(call submake_template,$(dir),mostlyclean)))
816 mostlyclean: $(mostlyclean_dirs:=_mostlyclean)
817 for dir in test/automated; do \
818 [ ! -d $$dir ] || $(MAKE) -C $$dir mostlyclean; \
819 done
821 ### 'clean'
822 ### Delete all files from the current directory that are normally
823 ### created by building the program. Don't delete the files that
824 ### record the configuration. Also preserve files that could be made
825 ### by building, but normally aren't because the distribution comes
826 ### with them.
828 ### Delete '.dvi' files here if they are not part of the distribution.
829 clean_dirs = $(mostlyclean_dirs) nextstep
831 $(foreach dir,$(clean_dirs),$(eval $(call submake_template,$(dir),clean)))
833 clean: $(clean_dirs:=_clean)
834 for dir in test/automated; do \
835 [ ! -d $$dir ] || $(MAKE) -C $$dir clean; \
836 done
837 -rm -f *.tmp etc/*.tmp*
838 -rm -rf info-dir.*
840 ### 'bootclean'
841 ### Delete all files that need to be remade for a clean bootstrap.
842 top_bootclean=\
843 rm -f config.cache config.log ${srcdir}/doc/man/emacs.1
845 ### 'distclean'
846 ### Delete all files from the current directory that are created by
847 ### configuring or building the program. If you have unpacked the
848 ### source and built the program without creating any other files,
849 ### 'make distclean' should leave only the files that were in the
850 ### distribution.
851 top_distclean=\
852 ${top_bootclean}; \
853 rm -f config.status config.log~ Makefile stamp-h1 ${SUBDIR_MAKEFILES}
855 distclean_dirs = $(clean_dirs) leim lisp
857 $(foreach dir,$(distclean_dirs),$(eval $(call submake_template,$(dir),distclean)))
859 distclean: $(distclean_dirs:=_distclean)
860 for dir in test/automated admin/grammars admin/unidata; do \
861 [ ! -d $$dir ] || $(MAKE) -C $$dir distclean; \
862 done
863 ${top_distclean}
865 ### 'bootstrap-clean'
866 ### Delete everything that can be reconstructed by 'make' and that
867 ### needs to be deleted in order to force a bootstrap from a clean state.
868 $(foreach dir,$(distclean_dirs),$(eval $(call submake_template,$(dir),bootstrap-clean)))
870 bootstrap-clean: $(distclean_dirs:=_bootstrap-clean)
871 for dir in test/automated admin/grammars admin/unidata; do \
872 [ ! -d $$dir ] || $(MAKE) -C $$dir bootstrap-clean; \
873 done
874 [ ! -f config.log ] || mv -f config.log config.log~
875 rm -rf ${srcdir}/info
876 rm -f ${srcdir}/etc/refcards/emacsver.tex
877 ${top_bootclean}
879 ### 'maintainer-clean'
880 ### Delete everything from the current directory that can be
881 ### reconstructed with this Makefile. This typically includes
882 ### everything deleted by distclean, plus more: C source files
883 ### produced by Bison, tags tables, info files, and so on.
885 ### One exception, however: 'make maintainer-clean' should not delete
886 ### 'configure' even if 'configure' can be remade using a rule in the
887 ### Makefile. More generally, 'make maintainer-clean' should not delete
888 ### anything that needs to exist in order to run 'configure' and then
889 ### begin to build the program.
890 top_maintainer_clean=\
891 ${top_distclean}; \
892 rm -fr autom4te.cache
894 maintainer_clean_dirs = src leim lisp
896 $(foreach dir,$(maintainer_clean_dirs),$(eval $(call submake_template,$(dir),maintainer-clean)))
898 maintainer-clean: bootstrap-clean $(maintainer_clean_dirs:=_maintainer-clean)
899 for dir in test/automated admin/grammars admin/unidata; do \
900 [ ! -d $$dir ] || $(MAKE) -C $$dir maintainer-clean; \
901 done
902 ${top_maintainer_clean}
904 ### This doesn't actually appear in the coding standards, but Karl
905 ### says GCC supports it, and that's where the configuration part of
906 ### the coding standards seem to come from. It's like distclean, but
907 ### it deletes backup and autosave files too.
908 ### Note that we abuse this in some subdirectories (eg leim),
909 ### to delete some generated files that are slow to rebuild.
910 $(foreach dir,$(SUBDIR),$(eval $(call submake_template,$(dir),extraclean)))
912 ## FIXME this is busted because most of these do not have extraclean rules.
913 extraclean: $(SUBDIR:=_extraclean)
914 ${top_maintainer_clean}
915 -rm -f config-tmp-*
916 -rm -f *~ \#*
918 # The src subdir knows how to do the right thing
919 # even when the build directory and source dir are different.
920 .PHONY: TAGS tags
921 TAGS tags: lib lib-src src
922 $(MAKE) -C src tags
924 check: all
925 @if test ! -d test/automated; then \
926 echo "You do not seem to have the test/ directory."; \
927 echo "Maybe you are using a release tarfile, rather than a repository checkout."; \
928 else \
929 $(MAKE) -C test/automated check; \
932 dist:
933 cd ${srcdir}; ./make-dist
935 DVIS = lispref-dvi lispintro-dvi emacs-dvi misc-dvi
936 HTMLS = lispref-html lispintro-html emacs-html misc-html
937 INFOS = lispref-info lispintro-info emacs-info misc-info
938 PDFS = lispref-pdf lispintro-pdf emacs-pdf misc-pdf
939 PSS = lispref-ps lispintro-ps emacs-ps misc-ps
941 DOCS = $(DVIS) $(HTMLS) $(INFOS) $(PDFS) $(PSS)
942 $(DOCS):
943 $(MAKE) -C doc/$(subst -, ,$@)
945 .PHONY: $(DOCS) docs pdf ps
946 .PHONY: info dvi dist check html info-real info-dir check-info
948 ## TODO add etc/refcards.
949 docs: $(DOCS)
950 dvi: $(DVIS)
951 html: $(HTMLS)
952 info-real: $(INFOS)
953 pdf: $(PDFS)
954 ps: $(PSS)
956 info-dir: ${srcdir}/info/dir
958 ## Hopefully doc/misc/*.texi is not too long for some systems?
959 srcdir_doc_info_dir_inputs = \
960 ${srcdir}/doc/emacs/emacs.texi \
961 ${srcdir}/doc/lispintro/emacs-lisp-intro.texi \
962 ${srcdir}/doc/lispref/elisp.texi \
963 $(sort $(wildcard ${srcdir}/doc/misc/*.texi))
964 info_dir_inputs = \
965 ../build-aux/dir_top \
966 $(subst ${srcdir}/doc/,,${srcdir_doc_info_dir_inputs})
967 info_dir_deps = \
968 ${srcdir}/build-aux/make-info-dir \
969 ${srcdir}/build-aux/dir_top \
970 ${srcdir_doc_info_dir_inputs}
972 ## It would be much simpler if info/dir was only created in the
973 ## installation location by the install-info rule, but we also
974 ## need one in the source directory for people running uninstalled.
975 ## FIXME it would be faster to use the install-info program if we have it,
976 ## but then we would need to depend on info-real, which would
977 ## slow down parallelization.
978 ${srcdir}/info/dir: ${info_dir_deps}
979 $(AM_V_at)${MKDIR_P} ${srcdir}/info
980 $(AM_V_GEN)tempfile=info-dir.$$$$; \
981 rm -f $${tempfile}; \
982 (cd ${srcdir}/doc && \
983 AWK='${AWK}' ../build-aux/make-info-dir ${info_dir_inputs} \
984 ) >$$tempfile && \
985 ${srcdir}/build-aux/move-if-change $${tempfile} ${srcdir}/info/dir
987 INSTALL_DVI = install-emacs-dvi install-lispref-dvi \
988 install-lispintro-dvi install-misc-dvi
989 INSTALL_HTML = install-emacs-html install-lispref-html \
990 install-lispintro-html install-misc-html
991 INSTALL_PDF = install-emacs-pdf install-lispref-pdf \
992 install-lispintro-pdf install-misc-pdf
993 INSTALL_PS = install-emacs-ps install-lispref-ps \
994 install-lispintro-ps install-misc-ps
995 INSTALL_DOC = $(INSTALL_DVI) $(INSTALL_HTML) $(INSTALL_PDF) $(INSTALL_PS)
997 ## Install non .info forms of the documentation.
998 ## TODO add etc/refcards.
999 $(INSTALL_DOC):
1000 $(MAKE) -C doc/$(subst -, install-,$(subst install-,,$@))
1002 .PHONY: $(INSTALL_DOC) install-doc
1003 .PHONY: install-dvi install-html install-pdf install-ps
1005 install-doc: $(INSTALL_DOC)
1006 install-dvi: $(INSTALL_DVI)
1007 install-html: $(INSTALL_HTML)
1008 install-pdf: $(INSTALL_PDF)
1009 install-ps: $(INSTALL_PS)
1012 UNINSTALL_DVI = uninstall-emacs-dvi uninstall-lispref-dvi \
1013 uninstall-lispintro-dvi uninstall-misc-dvi
1014 UNINSTALL_HTML = uninstall-emacs-html uninstall-lispref-html \
1015 uninstall-lispintro-html uninstall-misc-html
1016 UNINSTALL_PDF = uninstall-emacs-pdf uninstall-lispref-pdf \
1017 uninstall-lispintro-pdf uninstall-misc-pdf
1018 UNINSTALL_PS = uninstall-emacs-ps uninstall-lispref-ps \
1019 uninstall-lispintro-ps uninstall-misc-ps
1020 UNINSTALL_DOC = $(UNINSTALL_DVI) $(UNINSTALL_HTML) $(UNINSTALL_PDF) $(UNINSTALL_PS)
1022 $(UNINSTALL_DOC):
1023 $(MAKE) -C doc/$(subst -, uninstall-,$(subst uninstall-,,$@))
1025 .PHONY: $(UNINSTALL_DOC) uninstall-doc
1026 .PHONY: uninstall-dvi uninstall-html uninstall-pdf uninstall-ps
1028 uninstall-doc: $(UNINSTALL_DOC)
1029 uninstall-dvi: $(UNINSTALL_DVI)
1030 uninstall-html: $(UNINSTALL_HTML)
1031 uninstall-pdf: $(UNINSTALL_PDF)
1032 uninstall-ps: $(UNINSTALL_PS)
1035 # Note that man/Makefile knows how to put the info files in $(srcdir),
1036 # so we can do ok running make in the build dir.
1037 # This used to have a clause that exited with an error if MAKEINFO = no.
1038 # But it is inappropriate to do so without checking if makeinfo is
1039 # actually needed - it is not if the info files are up-to-date. (Bug#3982)
1040 # Only the doc/*/Makefiles can decide that, so we let those rules run
1041 # and give a standard error if makeinfo is needed but missing.
1042 # While it would be nice to give a more detailed error message, that
1043 # would require changing every rule in doc/ that builds an info file,
1044 # and it's not worth it. This case is only relevant if you download a
1045 # release, then change the .texi files.
1046 info:
1047 ifneq ($(HAVE_MAKEINFO),no)
1048 $(MAKE) info-real info-dir
1049 endif
1051 ## build-aux/make-info-dir expects only certain dircategories.
1052 check-info: info
1053 cd info ; \
1054 bad= ; \
1055 for file in *; do \
1056 test -f "$${file}" || continue ; \
1057 case $${file} in \
1058 *-[0-9]*|COPYING|dir) continue ;; \
1059 esac ; \
1060 cat=`sed -n 's/^INFO-DIR-SECTION //p' $${file}`; \
1061 case $${cat} in \
1062 "Texinfo documentation system" | "Emacs"| "Emacs lisp" | \
1063 "Emacs editing modes" | "Emacs network features" | \
1064 "Emacs misc features" | "Emacs lisp libraries" ) : ;; \
1065 *) bad="$${bad} $${file}" ;; \
1066 esac; \
1067 done ; \
1068 if test -n "$${bad}"; then \
1069 echo "Unexpected dircategory in: $${bad}" ; \
1070 exit 1 ; \
1071 fi ; \
1072 echo "info files are OK"
1074 #### Bootstrapping.
1076 ### This first cleans the lisp subdirectory, removing all compiled
1077 ### Lisp files. Then re-run make to build all the files anew.
1079 .PHONY: bootstrap
1081 # Bootstrapping does the following:
1082 # * Remove files to start from a bootstrap-clean slate.
1083 # * Run autogen.sh.
1084 # * Rebuild Makefile, to update the build procedure itself.
1085 # * Do the actual build.
1086 bootstrap: bootstrap-clean
1087 cd $(srcdir) && ./autogen.sh
1088 $(MAKE) MAKEFILE_NAME=force-Makefile force-Makefile
1089 $(MAKE) all
1091 .PHONY: ChangeLog change-history change-history-commit
1092 .PHONY: master-branch-is-current no-ChangeLog unchanged-history-files
1094 # The newest revision that should not appear in the generated ChangeLog.
1095 gen_origin = 2c1b8604946efbcd8ec5dd6c6dda7541ce4fc3c0
1097 # Convert git commit log to ChangeLog file. make-dist uses this.
1098 ChangeLog:
1099 $(AM_V_GEN)distprefix=$(distprefix) srcprefix=$(srcdir)/ \
1100 $(srcdir)/build-aux/gitlog-to-emacslog $(gen_origin)
1102 # The ChangeLog history files are called ChangeLog.1, ChangeLog.2, ...,
1103 # ChangeLog.$(CHANGELOG_HISTORY_INDEX_MAX). $(CHANGELOG_N) stands for
1104 # the newest (highest-numbered) ChangeLog history file.
1105 CHANGELOG_HISTORY_INDEX_MAX = 2
1106 CHANGELOG_N = ChangeLog.$(CHANGELOG_HISTORY_INDEX_MAX)
1108 # Check that we are in a good state for changing history.
1109 no-ChangeLog:
1110 test ! -f ChangeLog
1111 master-branch-is-current:
1112 git branch | grep -q '^\* master$$'
1113 unchanged-history-files:
1114 x=$$(git diff-files --name-only $(CHANGELOG_N) Makefile.in) && \
1115 test -z "$$x"
1117 # Copy newer commit messages to the start of the ChangeLog history file,
1118 # and consider them to be older.
1119 change-history: no-ChangeLog master-branch-is-current unchanged-history-files \
1120 ChangeLog
1121 (sed '/^;; [L]ocal Variables:/,$$d' <ChangeLog && cat $(CHANGELOG_N)) \
1122 >$(CHANGELOG_N).tmp
1123 new_origin=$$(git log --pretty=format:%H HEAD^!) && \
1124 sed 's/^\(gen_origin *= *\).*/\1'"$$new_origin/" \
1125 <Makefile.in >Makefile.in.tmp
1126 mv $(CHANGELOG_N).tmp $(CHANGELOG_N)
1127 mv Makefile.in.tmp Makefile.in
1128 $(MAKE) $@-commit
1130 # If 'make change-history' fails because the newest ChangeLog history
1131 # file contains invalid text, fix the file by hand and then run
1132 # 'make change-history-commit'.
1133 change-history-commit:
1134 git commit -m'; make $@' $(CHANGELOG_N) Makefile.in
1136 .PHONY: check-declare
1138 check-declare:
1139 @if [ ! -f $(srcdir)/src/emacs ]; then \
1140 echo "You must build Emacs to use this command"; \
1141 exit 1; \
1143 $(MAKE) -C lisp $@